package com.tofly.feesapi.wxgl.wechatofficalacctmgt.controller;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.tofly.common.core.entity.ResultRespone;
import com.tofly.feesapi.wxgl.wechatofficalacctmgt.entity.WxLxdhsq;
import com.tofly.feesapi.wxgl.wechatofficalacctmgt.entity.dto.WxCommonDto;
import com.tofly.feesapi.wxgl.wechatofficalacctmgt.entity.vo.WxLxdhsqVo;
import com.tofly.feesapi.wxgl.wechatofficalacctmgt.service.WxLxdhsqService;
import lombok.AllArgsConstructor;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import org.springframework.web.bind.annotation.ModelAttribute;

import java.util.Arrays;

@RestController
@RequestMapping("/wxlxdhsq")
@Api(tags="微信-变更联系方式申请接口")
public class WxLxdhsqController {

    @Autowired
    private  WxLxdhsqService wxLxdhsqService;

    @GetMapping("/getpage")
    @ApiOperation(value = "自定义分页查询")
    public ResultRespone<Page<WxLxdhsqVo>> getWxLxdhsqPage(Page page, @ModelAttribute WxCommonDto dto) {
        ResultRespone<Page<WxLxdhsqVo>> resultRespone = new ResultRespone<>();
        try {
            Page<WxLxdhsqVo> wxPage = wxLxdhsqService.getWxLxdhsqPage(page, dto);
            resultRespone.setCode(1);
            resultRespone.setResult(wxPage);
        } catch (RuntimeException e) {
            resultRespone.setCode(-1);
            resultRespone.setMessage(e.getMessage());
        }
        return resultRespone;
    }


    @GetMapping("/page" )
    @ApiOperation(value = "分页查询")
    public ResultRespone getWxLxdhsqPage(Page page, @ModelAttribute WxLxdhsq wxLxdhsq) {
      return ResultRespone.success(wxLxdhsqService.page(page, Wrappers.query(wxLxdhsq)));
    }


    @GetMapping("/{id}" )
    @ApiOperation(value = "通过ID查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "id", value = "ID", required = true, dataType = "String")
    })
    public ResultRespone getById(@PathVariable("id" ) String id) {
      return ResultRespone.success(wxLxdhsqService.getById(id));
    }


    @ApiOperation(value = "新增微信-变更联系方式申请")
    @PostMapping
    public ResultRespone save(@RequestBody WxLxdhsq wxLxdhsq) {
      return ResultRespone.success(wxLxdhsqService.save(wxLxdhsq));
    }


    @ApiOperation(value = "修改微信-变更联系方式申请")
    @PutMapping
    public ResultRespone updateById(@RequestBody WxLxdhsq wxLxdhsq) {
      return ResultRespone.success(wxLxdhsqService.updateById(wxLxdhsq));
    }


    @ApiOperation(value = "通过ID删除微信-变更联系方式申请")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "id", value = "ID", required = true, dataType = "String")
    })
    @DeleteMapping("/{id}" )
    public ResultRespone removeById(@PathVariable String id) {
      return ResultRespone.success(wxLxdhsqService.removeById(id));
    }


    @ApiOperation(value = "通过ID批量删除微信-变更联系方式申请")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "ids", value = "批量删除，多个id以逗号隔开", required = true, dataType = "String")
    })
    @DeleteMapping("/deleteByIds" )
    public ResultRespone removeByIds(String ids) {
        return ResultRespone.success(wxLxdhsqService.removeByIds(Arrays.asList(ids.split(","))));
    }
}
